config/routes.rb
Rails.application.routes.draw do
  devise_for :users, skip: [:registrations]
  as :user do
    get "users/edit" => "devise/registrations#edit", :as => "edit_user_registration"
    put "users" => "devise/registrations#update", :as => "user_registration"
  end

  get "home/index"
  resources :milestones
  resources :time_offs
  resources :team_members
  resources :labels
  resources :teams

  get "up" => "rails/health#show", :as => :rails_health_check

  devise_scope :user do
    authenticated :user do
      root "home#index", as: :authenticated_root
    end

    unauthenticated do
      root "devise/sessions#new", as: :unauthenticated_root
    end
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/assignment.rb
class Assignment < ApplicationRecord
  belongs_to :team_member
  belongs_to :team_milestone
end

app/models/capacity.rb
class Capacity < ApplicationRecord
  belongs_to :team_member
  belongs_to :team_milestone
end

app/models/label.rb
class Label < ApplicationRecord
  belongs_to :team
end

app/models/milestone.rb
class Milestone < ApplicationRecord
  has_many :team_milestones, dependent: :destroy

  validates :milestone, presence: true
  validates :gitlab_id, presence: true
  validates :start_date, presence: true
  validates :end_date, presence: true
end

app/models/team.rb
class Team < ApplicationRecord
  belongs_to :user
  has_many :team_members, dependent: :destroy

  validates :name, presence: true
end

app/models/team_member.rb
class TeamMember < ApplicationRecord
  belongs_to :team
  has_many :capacities, dependent: :destroy
  has_many :team_milestones, through: :capacities
  has_many :assignments, dependent: :destroy
  # has_many :team_milestones, through: :assignments

  validates :name, presence: true
  validates :handle, presence: true
  validates :gitlab_id, presence: true
end

app/models/team_milestone.rb
class TeamMilestone < ApplicationRecord
  belongs_to :team
  belongs_to :milestone
  has_many :assignments
  has_many :capacities
end

app/models/time_off.rb
class TimeOff < ApplicationRecord
  belongs_to :team_member

  validates :start_date, presence: true
  validates :end_date, presence: true
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
    :recoverable, :rememberable, :validatable
  has_many :teams, dependent: :nullify
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
    @teams = current_user.teams
  end
end

app/controllers/labels_controller.rb
class LabelsController < ApplicationController
  before_action :set_label, only: %i[show edit update destroy]

  def index
    @labels = Label.all
  end

  def show
  end

  def new
    @label = Label.new
  end

  def edit
  end

  def create
    @label = Label.new(label_params)

    if @label.save
      redirect_to @label, notice: "Label was successfully created."
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @label.update(label_params)
      redirect_to @label, notice: "Label was successfully updated.", status: :see_other
    else
      render :edit, status: :unprocessable_entity
    end
  end

  # DELETE /labels/1
  def destroy
    @label.destroy!
    redirect_to labels_url, notice: "Label was successfully destroyed.", status: :see_other
  end

  private

  def set_label
    @label = Label.find(params[:id])
  end

  def label_params
    params.require(:label).permit(:team_id)
  end
end

app/controllers/milestones_controller.rb
class MilestonesController < ApplicationController
  before_action :set_milestone, only: %i[show edit update destroy]

  def index
    @milestones = Milestone.all
  end

  def show
  end

  def new
    @milestone = Milestone.new
  end

  def edit
  end

  def create
    @milestone = Milestone.new(milestone_params)

    if @milestone.save
      redirect_to @milestone, notice: "Milestone was successfully created."
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @milestone.update(milestone_params)
      redirect_to @milestone, notice: "Milestone was successfully updated.", status: :see_other
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @milestone.destroy!
    redirect_to milestones_url, notice: "Milestone was successfully destroyed.", status: :see_other
  end

  private

  def set_milestone
    @milestone = Milestone.find(params[:id])
  end

  def milestone_params
    params.require(:milestone).permit(:milestone, :start_date, :end_date, :last_working_day, :workdays, :weight, :gitlab_id)
  end
end

app/controllers/team_members_controller.rb
class TeamMembersController < ApplicationController
  before_action :set_team_member, only: %i[show edit update destroy]

  def index
    @team_members = TeamMember.all
  end

  def show
  end

  def new
    @team_member = TeamMember.new
  end

  def edit
  end

  def create
    @team_member = TeamMember.new(team_member_params)

    if @team_member.save
      redirect_to @team_member, notice: "Team member was successfully created."
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @team_member.update(team_member_params)
      redirect_to @team_member, notice: "Team member was successfully updated.", status: :see_other
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @team_member.destroy!
    redirect_to team_members_url, notice: "Team member was successfully destroyed.", status: :see_other
  end

  private

  def set_team_member
    @team_member = TeamMember.find(params[:id])
  end

  def team_member_params
    params.require(:team_member).permit(:team_id, :name, :handle, :gitlab_id, :active)
  end
end

app/controllers/teams_controller.rb
class TeamsController < ApplicationController
  before_action :set_team, only: %i[show edit update destroy]

  def index
    @teams = Team.all
  end

  def show
  end

  def new
    @team = Team.new
  end

  def edit
  end

  def create
    @team = Team.new(team_params)

    if @team.save
      redirect_to @team, notice: "Team was successfully created."
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @team.update(team_params)
      redirect_to @team, notice: "Team was successfully updated.", status: :see_other
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @team.destroy!
    redirect_to teams_url, notice: "Team was successfully destroyed.", status: :see_other
  end

  private

  def set_team
    @team = Team.find(params[:id])
  end

  def team_params
    params.require(:team).permit(:user_id, :name, :project)
  end
end

app/controllers/time_offs_controller.rb
class TimeOffsController < ApplicationController
  before_action :set_time_off, only: %i[show edit update destroy]

  def index
    @time_offs = TimeOff.all
  end

  def show
  end

  def new
    @time_off = TimeOff.new
  end

  def edit
  end

  def create
    @time_off = TimeOff.new(time_off_params)

    if @time_off.save
      redirect_to @time_off, notice: "Time off was successfully created."
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @time_off.update(time_off_params)
      redirect_to @time_off, notice: "Time off was successfully updated.", status: :see_other
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @time_off.destroy!
    redirect_to time_offs_url, notice: "Time off was successfully destroyed.", status: :see_other
  end

  private

  def set_time_off
    @time_off = TimeOff.find(params[:id])
  end

  def time_off_params
    params.require(:time_off).permit(:team_member_id, :start_date, :end_date, :days)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/home/index.html.erb
<h1>My Teams</h1>

<% if @teams.any? %>
  <%= render partial: 'teams/index/teams', locals: { teams: @teams } %>
<% else %>
  <p>The teams you manage will show up here when they are created</p>
<% end %>

<%= link_to "New team", new_team_path %>

app/views/labels/_form.html.erb
<%= form_with(model: label) do |form| %>
  <% if label.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(label.errors.count, "error") %> prohibited this label from being saved:</h2>

      <ul>
        <% label.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :team_id, style: "display: block" %>
    <%= form.text_field :team_id %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/labels/_label.html.erb
<div id="<%= dom_id label %>">
  <p>
    <strong>Team:</strong>
    <%= label.team_id %>
  </p>

</div>

app/views/labels/edit.html.erb
<h1>Editing label</h1>

<%= render "form", label: @label %>

<br>

<div>
  <%= link_to "Show this label", @label %> |
  <%= link_to "Back to labels", labels_path %>
</div>

app/views/labels/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Labels</h1>

<div id="labels">
  <% @labels.each do |label| %>
    <%= render label %>
    <p>
      <%= link_to "Show this label", label %>
    </p>
  <% end %>
</div>

<%= link_to "New label", new_label_path %>

app/views/labels/new.html.erb
<h1>New label</h1>

<%= render "form", label: @label %>

<br>

<div>
  <%= link_to "Back to labels", labels_path %>
</div>

app/views/labels/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @label %>

<div>
  <%= link_to "Edit this label", edit_label_path(@label) %> |
  <%= link_to "Back to labels", labels_path %>

  <%= button_to "Destroy this label", @label, method: :delete %>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Milestone Planner</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/picnic@7.1.0/picnic.min.css">
    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= render partial: 'layouts/partials/flash' if flash.any? %>
    <%= render partial: 'layouts/partials/nav' %>
    <main>
      <section>
        <article>
          <%= yield %>
        </article>
      </section>
    </main>
  </body>
</html>

app/views/layouts/devise_layout.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Milestone Planner</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/picnic@7.1.0/picnic.min.css">
    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= render partial: 'layouts/partials/flash' if flash.any? %>
    <main>
      <section>
        <h1>GitLab Milestone Planner</h1>
        <%= yield %>
      </section>
    </main>
  </body>
</html>

app/views/layouts/partials/_flash.html.erb
<p class="notice"><%= notice %></p>
<p class="alert"><%= alert %></p>

app/views/layouts/partials/_nav.html.erb
<% if action_name == 'index' %>
  <nav class="demo">
    <a href="/" class="brand">
      <span>Milestone Planner</span>
    </a>

    <input id="bmenub" type="checkbox" class="show">
    <label for="bmenub" class="burger pseudo button">menu</label>

    <div class="menu">
      <%= link_to "Teams", teams_path, class: "pseudo button icon-help-circled" %>
      <%= link_to "Milestones", milestones_path, class: "pseudo button icon-help-circled" %>
      <% if current_user %>
        <%= link_to "Log out", destroy_user_session_path, data: { turbo_method: :delete } %>
      <% else %>
        <%= link_to "Log in", new_user_session_path %>
      <% end %>
    </div>
  </nav>
<% else %>
  <nav>
    <div class="menu">
      <%= link_to 'X', :back, class: "button pseudo" %>
    </div>
  </nav>
<% end %>

app/views/milestones/_form.html.erb
<%= form_with(model: milestone) do |form| %>
  <% if milestone.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(milestone.errors.count, "error") %> prohibited this milestone from being saved:</h2>

      <ul>
        <% milestone.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :milestone, style: "display: block" %>
    <%= form.text_field :milestone %>
  </div>

  <div>
    <%= form.label :start_date, style: "display: block" %>
    <%= form.date_field :start_date %>
  </div>

  <div>
    <%= form.label :end_date, style: "display: block" %>
    <%= form.date_field :end_date %>
  </div>

  <div>
    <%= form.label :last_working_day, style: "display: block" %>
    <%= form.date_field :last_working_day %>
  </div>

  <div>
    <%= form.label :workdays, style: "display: block" %>
    <%= form.number_field :workdays %>
  </div>

  <div>
    <%= form.label :weight, style: "display: block" %>
    <%= form.number_field :weight %>
  </div>

  <div>
    <%= form.label :gitlab_id, style: "display: block" %>
    <%= form.number_field :gitlab_id %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/milestones/_milestone.html.erb
<div id="<%= dom_id milestone %>">
  <p>
    <strong>Milestone:</strong>
    <%= milestone.milestone %>
  </p>

  <p>
    <strong>Start date:</strong>
    <%= milestone.start_date %>
  </p>

  <p>
    <strong>End date:</strong>
    <%= milestone.end_date %>
  </p>

  <p>
    <strong>Last working day:</strong>
    <%= milestone.last_working_day %>
  </p>

  <p>
    <strong>Workdays:</strong>
    <%= milestone.workdays %>
  </p>

  <p>
    <strong>Weight:</strong>
    <%= milestone.weight %>
  </p>

  <p>
    <strong>Gitlab:</strong>
    <%= milestone.gitlab_id %>
  </p>

</div>

app/views/milestones/edit.html.erb
<h1>Editing milestone</h1>

<%= render "form", milestone: @milestone %>

<br>

<div>
  <%= link_to "Delete Milestone", @milestone, method: :delete %>
</div>

app/views/milestones/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Milestones</h1>

<table class="primary">
  <thead>
    <tr>
      <th>Milestone</th>
      <th>Start</th>
      <th>End</th>
      <th>Last Day</th>
      <th>Workdays</th>
      <th>Weight</th>
    </tr>
  </thead>
  <tbody>
    <% @milestones.each do |milestone| %>
      <tr>
        <td><%= link_to milestone.milestone, milestone %></td>
        <td><%= milestone.start_date %></td>
        <td><%= milestone.end_date %></td>
        <td><%= milestone.last_working_day %></td>
        <td><%= milestone.workdays %></td>
        <td><%= milestone.weight %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= link_to "New milestone", new_milestone_path %>

app/views/milestones/new.html.erb
<h1>New milestone</h1>

<%= render "form", milestone: @milestone %>

<br>

<div>
  <%= link_to "Back to milestones", milestones_path %>
</div>

app/views/milestones/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @milestone %>

<div>
  <%= link_to "Edit", edit_milestone_path(@milestone) %>
</div>

app/views/team_members/_form.html.erb
<%= form_with(model: team_member) do |form| %>
  <% if team_member.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(team_member.errors.count, "error") %> prohibited this team_member from being saved:</h2>

      <ul>
        <% team_member.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :team_id, style: "display: block" %>
    <%= form.text_field :team_id %>
  </div>

  <div>
    <%= form.label :name, style: "display: block" %>
    <%= form.text_field :name %>
  </div>

  <div>
    <%= form.label :handle, style: "display: block" %>
    <%= form.text_field :handle %>
  </div>

  <div>
    <%= form.label :gitlab_id, style: "display: block" %>
    <%= form.number_field :gitlab_id %>
  </div>

  <div>
    <%= form.label :active, style: "display: block" %>
    <%= form.check_box :active %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/team_members/_team_member.html.erb
<div id="<%= dom_id team_member %>">
  <p>
    <strong>Team:</strong>
    <%= team_member.team_id %>
  </p>

  <p>
    <strong>Name:</strong>
    <%= team_member.name %>
  </p>

  <p>
    <strong>Handle:</strong>
    <%= team_member.handle %>
  </p>

  <p>
    <strong>Gitlab:</strong>
    <%= team_member.gitlab_id %>
  </p>

  <p>
    <strong>Active:</strong>
    <%= team_member.active %>
  </p>

</div>

app/views/team_members/edit.html.erb
<h1>Editing team member</h1>

<%= render "form", team_member: @team_member %>

<br>

<div>
  <%= link_to "Show this team member", @team_member %> |
  <%= link_to "Back to team members", team_members_path %>
</div>

app/views/team_members/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Team members</h1>

<div id="team_members">
  <% @team_members.each do |team_member| %>
    <%= render team_member %>
    <p>
      <%= link_to "Show this team member", team_member %>
    </p>
  <% end %>
</div>

<%= link_to "New team member", new_team_member_path %>

app/views/team_members/new.html.erb
<h1>New team member</h1>

<%= render "form", team_member: @team_member %>

<br>

<div>
  <%= link_to "Back to team members", team_members_path %>
</div>

app/views/team_members/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @team_member %>

<div>
  <%= link_to "Edit this team member", edit_team_member_path(@team_member) %> |
  <%= link_to "Back to team members", team_members_path %>

  <%= button_to "Destroy this team member", @team_member, method: :delete %>
</div>

app/views/time_offs/_form.html.erb
<%= form_with(model: time_off) do |form| %>
  <% if time_off.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(time_off.errors.count, "error") %> prohibited this time_off from being saved:</h2>

      <ul>
        <% time_off.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :team_member_id, style: "display: block" %>
    <%= form.text_field :team_member_id %>
  </div>

  <div>
    <%= form.label :start_date, style: "display: block" %>
    <%= form.date_field :start_date %>
  </div>

  <div>
    <%= form.label :end_date, style: "display: block" %>
    <%= form.date_field :end_date %>
  </div>

  <div>
    <%= form.label :days, style: "display: block" %>
    <%= form.number_field :days %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/time_offs/_time_off.html.erb
<div id="<%= dom_id time_off %>">
  <p>
    <strong>Team member:</strong>
    <%= time_off.team_member_id %>
  </p>

  <p>
    <strong>Start date:</strong>
    <%= time_off.start_date %>
  </p>

  <p>
    <strong>End date:</strong>
    <%= time_off.end_date %>
  </p>

  <p>
    <strong>Days:</strong>
    <%= time_off.days %>
  </p>

</div>

app/views/time_offs/edit.html.erb
<h1>Editing time off</h1>

<%= render "form", time_off: @time_off %>

<br>

<div>
  <%= link_to "Show this time off", @time_off %> |
  <%= link_to "Back to time offs", time_offs_path %>
</div>

app/views/time_offs/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Time offs</h1>

<div id="time_offs">
  <% @time_offs.each do |time_off| %>
    <%= render time_off %>
    <p>
      <%= link_to "Show this time off", time_off %>
    </p>
  <% end %>
</div>

<%= link_to "New time off", new_time_off_path %>

app/views/time_offs/new.html.erb
<h1>New time off</h1>

<%= render "form", time_off: @time_off %>

<br>

<div>
  <%= link_to "Back to time offs", time_offs_path %>
</div>

app/views/time_offs/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @time_off %>

<div>
  <%= link_to "Edit this time off", edit_time_off_path(@time_off) %> |
  <%= link_to "Back to time offs", time_offs_path %>

  <%= button_to "Destroy this time off", @time_off, method: :delete %>
</div>